define(['core', 'tpl'], function (core, tpl) {
    var modal = {
        params: {}
    };
    var paypassword="";
    modal.init = function (params) {
        var defaults = {
            orderid: 0,
            wechat: {
                success: false
            },
            cash: {
                success: false
            },
            alipay: {
                success: false
            },
        };
        modal.params = $.extend(defaults, params || {});
        $('.pay-btn').unbind('click').click(function () {
            var btn = $(this);
            core.json('order/pay/check', {
                id: modal.params.orderid
            }, function (pay_json) {
                if (pay_json.status == 1) {
                    modal.pay(btn)
                } else {
                    FoxUI.toast.show(pay_json.result.message)
                }
            }, false, true)
        });
        if (modal.params.wechat.jie == 1) {
            $('.pay-btn[data-type="wechat"]').click()
        }
        setInterval(function(){
            core.json('order/pay/orderstatus2',{orderid: modal.params.orderid},function(res){
                if(res.code==10000){
                    FoxUI.toast.show('成功')
                    location.href= core.getUrl('order/detail', {
                        id: modal.params.orderid,
                    })
                }
            })
        },500)
    };
    modal.pay = function (btn) {
        var type = btn.data('type') || '';
        if (type == '') {
            return
        }
        if (btn.attr('stop')) {
            return
        }
        btn.attr('stop', 1);
        if (type == 'wechat') {
            modal.delectwxh5()
          
            if (core.ish5app()) {
                appPay('wechat', null, null, true);
                return
            }
            modal.payWechat(btn)
        } else if (type == 'alipay') {
            modal.delectwxh5()
            if (core.ish5app()) {
                appPay('alipay', null, null, true);
                return
            }
            modal.payAlipay(btn)
        }else if(type == 'wechat_h5'){
     
            modal.delectwxh5()
            btn.removeAttr('stop');
            modal.wxh5(btn)
        }else if(type == 'alipayh5'){
            modal.delectwxh5()
            btn.removeAttr('stop');
            modal.alipayh5(btn)
        } else if (type == 'credit'|| type == 'account_limit') {
            core.json('order/pay/check_pwd2',{},function(res){
                if(res.code==0){
                    layer.msg(res.msg);
                    setTimeout(function () {
                        location.href= core.getUrl('member/changepwd')
                    },1500)
                }else{
                    modal.delectwxh5();
                    paypassword=btn;
                    btn.removeAttr('stop');
                    $(".ftc_wzsf").show();
                }
            })
        //    layer.prompt( {formType: 1,
        //         title: '请输入支付密码',
        //         end:function() {
        //             btn.removeAttr('stop')
        //         },yes:function (index) {
        //             var pwd=$("input[type='password']").val();
        //             if (pwd=='') {
        //                 layer.msg('请输入支付密码');
        //             }else {
        //                 layer.close(index);
        //                 FoxUI.confirm('确认要支付吗?', '提醒', function () {
        //                     modal.complete(btn,type,pwd);
        //                 }, function () {
        //                     btn.removeAttr('stop');
        //                 })
        //             }
        //         }
        //     }, function(value, index, elem){

        //     });
        paypassword=btn;
        btn.removeAttr('stop');

        $(".ftc_wzsf").show();
        } else if (type == 'peerpay') {
            modal.delectwxh5()
            location.href = core.getUrl('order/pay/peerpay', {
                id: modal.params.orderid
            });
            return
        } else {
            modal.complete(btn, type)
        }
    };
    modal.payWechat = function (btn) {
        var wechat = modal.params.wechat;
        if (!wechat.success) {
            return
        }
        if (wechat.weixin) {
            function onBridgeReady() {
                WeixinJSBridge.invoke('getBrandWCPayRequest', {
                    'appId': wechat.appid ? wechat.appid : wechat.appId,
                    'timeStamp': wechat.timeStamp,
                    'nonceStr': wechat.nonceStr,
                    'package': wechat.package,
                    'signType': wechat.signType,
                    'paySign': wechat.paySign
                }, function (res) {
                    if (res.err_msg == 'get_brand_wcpay_request:ok') {
                        modal.complete(btn, 'wechat')
                    } else if (res.err_msg == 'get_brand_wcpay_request:cancel') {
                        FoxUI.toast.show('取消支付')
                    } else {
                        FoxUI.toast.show(res.err_msg)
                    }
                    btn.removeAttr('stop')
                })
            }
            if  (typeof WeixinJSBridge  ==  "undefined") {
                if ( document.addEventListener ) {
                    document.addEventListener('WeixinJSBridgeReady',  onBridgeReady,  false)
                } else  if  (document.attachEvent) {
                    document.attachEvent('WeixinJSBridgeReady',  onBridgeReady);
                    document.attachEvent('onWeixinJSBridgeReady',  onBridgeReady)
                }
            } else {
                onBridgeReady()
            }
        }
        if (wechat.weixin_jie || wechat.jie == 1) {
            modal.payWechatJie(btn, wechat)
        }
    };
    modal.payWechatJie = function (btn, wechat) {
        var img = core.getUrl('index/qr', {
            url: wechat.code_url
        });
        $('#qrmoney').text(modal.params.money);
        $('.order-weixinpay-hidden').show();
        $('#btnWeixinJieCancel').unbind('click').click(function () {
            btn.removeAttr('stop');
            clearInterval(settime);
            $('.order-weixinpay-hidden').hide()
        });
        var settime = setInterval(function () {
            $.getJSON(core.getUrl('order/pay/orderstatus'), {
                id: modal.params.orderid
            }, function (data) {
                if (data.status >= 1) {
                    clearInterval(settime);
                    location.href = core.getUrl('order/pay/success', {
                        id: modal.params.orderid
                    })
                }
            })
        }, 1000);
        $('.verify-pop').find('.close').unbind('click').click(function () {
            $('.order-weixinpay-hidden').hide();
            btn.removeAttr('stop');
            clearInterval(settime)
        });
        $('.verify-pop').find('.qrimg').attr('src', img).show()
    };
    modal.delectwxh5=function(){
        core.json('order/pay/delectwxh5',{orderid: modal.params.orderid},function(res){

        })
    }
    modal.wxh5 = function (btn) {
        var moblietype="";
        var u = navigator.userAgent, app = navigator.appVersion;
        var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //g
        var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
        if (isAndroid) {
           //这个是安卓操作系统
           moblietype="android"
        }
        if (isIOS) {
            moblietype="ios"
    　　　　//这个是ios操作系统
        }
        core.json('order/pay/wechat_h5',{orderid: modal.params.orderid,type: moblietype},function(res){
            // console.log(res);
            // return
            // alert(res.msg);
            if(res.code==10000){
                FoxUI.loader.show('mini');
                $("#wxpayif").attr("src",res.msg)
                location.href=res.msg
            }
            setInterval(function(){
                FoxUI.loader.hide();
                core.json('order/pay/orderstatus2',{orderid: modal.params.orderid},function(res){
                    if(res.code==10000){
                        FoxUI.toast.show('成功')
                        location.href= core.getUrl('order/detail', {
                            id: modal.params.orderid,
                        })
                    }
                })
            },500)
        },false, true)
    };
    modal.payAlipay = function (btn) {
        var alipay = modal.params.alipay;
        if (!alipay.success) {
            return
        }
        // FoxUI.loader.show('mini');
        // $("#wxpayif").attr("src",core.getUrl('order/pay_alipay', {
        //     orderid: modal.params.orderid,
        //     type: 0,
        //     url: alipay.url
        // }))
        
        location.href = core.getUrl('order/pay_alipay', {
            orderid: modal.params.orderid,
            type: 0,
            url: alipay.url
        })
        // setInterval(function(){
        //     FoxUI.loader.hide();
        //     core.json('order/pay/orderstatus2',{orderid: modal.params.orderid},function(res){
        //         if(res.code==10000){
        //             FoxUI.toast.show('成功')
        //             location.href= core.getUrl('order/detail', {
        //                 id: modal.params.orderid,
        //             })
        //         }
        //     })
        // },500)
    };
    modal.alipayh5 =function(){
        var alipay = modal.params.alipay;
        FoxUI.loader.show('mini');
        $("#wxpayif").attr("src",core.getUrl('order/pay_alipay', {
            orderid: modal.params.orderid,
            type: 0,
            url: alipay.url
        }))
        // setInterval(function(){
        //     FoxUI.loader.hide();
        //     core.json('order/pay/orderstatus2',{orderid: modal.params.orderid},function(res){
        //         if(res.code==10000){
        //             FoxUI.toast.show('成功')
        //             location.href= core.getUrl('order/detail', {
        //                 id: modal.params.orderid,
        //             })
        //         }
        //     })
        // },500)
    }
    modal.complete = function (btn, type,pwd2='') {
        var peerpay = $('#peerpay').text();
        var peerpaymessage = $('#peerpaymessage').val();
        FoxUI.loader.show('mini');
        setTimeout(function () {
            core.json('order/pay/complete', {
                id: modal.params.orderid,
                ordersn: modal.params.ordersn,
                type: type,
                peerpay: peerpay,
                peerpaymessage: peerpaymessage,
                pwd2:pwd2
            }, function (pay_json) {
                if (pay_json.status == 1) {
                    location.href = core.getUrl('order/pay/success', {
                        id: modal.params.orderid,
                        result: pay_json.result.result
                    });
                    return
                }
                FoxUI.loader.hide();
                btn.removeAttr('stop');
                FoxUI.toast.show(pay_json.result.message)
            }, false, true)
        }, 1000)
    };
    //出现浮动层
    $(".ljzf_but").click(function(){
        $(".ftc_wzsf").show();
    });
    //关闭浮动
    $(".close").click(function(){
        $(".ftc_wzsf").hide();
        $(".mm_box li").removeClass("mmdd");
        $(".mm_box li").attr("data","");
        i = 0;
    });
        //数字显示隐藏
    $(".xiaq_tb").click(function(){
        $(".numb_box").slideUp(500);
    });
    $(".mm_box").click(function(){
        $(".numb_box").slideDown(500);
    });
    $("#backorder").click(function(){
        location.href="https://www.cddwood.com/app/index.php?i=8&c=entry&m=ewei_shopv2&do=mobile&r=order&status=0"
    });
        //----
    var i = 0;
    $(".nub_ggg li .zf_num").click(function(){
            
        if(i<6){
            $(".mm_box li").eq(i).addClass("mmdd");
            $(".mm_box li").eq(i).attr("data",$(this).text());
            i++
            if (i==6) {
                var pwd = "";
                $(".mm_box li").each(function(){
                    pwd += $(this).attr("data");
                });
                var type = paypassword.data('type') || '';
                // console.log(pwd);
                // console.log(type);
                // console.log(paypassword);
                // return;
                modal.complete(paypassword,type,pwd);
            };
        } 
    });
        
    $(".nub_ggg li .zf_del").click(function(){
        if(i>0){
            i--
            $(".mm_box li").eq(i).removeClass("mmdd");
            $(".mm_box li").eq(i).attr("data","");
        }
    });

    $(".nub_ggg li .zf_empty").click(function(){
        $(".mm_box li").removeClass("mmdd");
        $(".mm_box li").attr("data","");
        i = 0;
    });
    return modal
});